unit fClientMain;

interface

uses
  Windows, Forms, Classes, Controls, Grids, StdCtrls;
  
type
  TfrmClientMain = class(TForm)
    Grid: TStringGrid;
    btnGetData: TButton;
    btnClear: TButton;
    procedure FormCreate(Sender: TObject);
    procedure btnGetDataClick(Sender: TObject);
    procedure btnClearClick(Sender: TObject);
  private
    procedure ClearGrid;
  public
  end;

var
  frmClientMain: TfrmClientMain;

implementation

uses SysUtils, TEST_007_TLB;

{$R *.dfm}

procedure TfrmClientMain.FormCreate(Sender: TObject);
begin
  Left := 50;
  Top := 50;
  Grid.ColWidths[0] := 65;
  Grid.Cells[0,0] := '';
  Grid.Cells[1,0] := '}L';
  Grid.Cells[2,0] := '̰';
  Grid.Cells[3,0] := '̧C';
  Grid.Cells[4,0] := 'L';
  Grid.Cells[5,0] := 'q';
end;

procedure TfrmClientMain.btnGetDataClick(Sender: TObject);
var
  I, Count: Integer;
  Intf: IIntfFile;
  F: IIStkDataFile;
  P: IIStkDataFileRec;
  FileName: string;
begin
  ClearGrid;
  Count := 300;
  Grid.RowCount := Count + 1;
  Intf := CoIntfFile.Create;
  FileName := GetCurrentDir + '\TEST.DAT';
  if (Intf <> nil) and Intf.GetStkDataFile(FileName, F) then
  try
    for I := 0 to Count-1 do
      if F.Rec(I, P) then
      begin
        Grid.Cells[0, I+1] := FormatDateTime('YYYY-MM-DD', P.Date);
        Grid.Cells[1, I+1] := Format('%.2f', [P.OP]);
        Grid.Cells[2, I+1] := Format('%.2f', [P.HP]);
        Grid.Cells[3, I+1] := Format('%.2f', [P.LP]);
        Grid.Cells[4, I+1] := Format('%.2f', [P.CP]);
        Grid.Cells[5, I+1] := Format('%.0f', [P.VOL]);
      end;
  finally
    //F := nil;   //iٲ
    //Intf := nil;//iٲ
  end;
end;

procedure TfrmClientMain.ClearGrid;
var
  I: Integer;
begin
  Grid.RowCount := 2;
  for I := 1 to Grid.RowCount-1 do
    Grid.Rows[I].Clear;
end;

procedure TfrmClientMain.btnClearClick(Sender: TObject);
begin
  ClearGrid;
end;

end.
 