unit fDef;

interface

uses Classes;

type
{ TStkDataFileRec }
  PStkDataFileRec = ^TStkDataFileRec;
	TStkDataFileRec = packed record
    Date: TDateTime;					//
    OP,HP,LP,CP,VOL: Single;	//L,}L,̰,̧C,^,q
  end;

{ TStkDataFileRec }  
  TStkDataFile = class(TPersistent)
  private
    function GetRec(Index: Integer): PStkDataFileRec;
  protected
    M: TMemoryStream;
  public
    constructor Create(const FileName: string);
    destructor Destroy; override;
    function Count: Integer;
    property Rec[Index: Integer]: PStkDataFileRec read GetRec; default; 
  end;

implementation

uses SysUtils;

{ TStkDataFile }

function TStkDataFile.Count: Integer;
begin
  Result := M.Size div SizeOf(TStkDataFileRec);
end;

constructor TStkDataFile.Create(const FileName: string);
begin
  inherited Create;
  M := TMemoryStream.Create;
  if FileExists(FileName) then
    M.LoadFromFile(FileName);
  M.Position := 0;
end;

destructor TStkDataFile.Destroy;
begin
  FreeAndNil(M);
  inherited;
end;

function TStkDataFile.GetRec(Index: Integer): PStkDataFileRec;
begin
  Result := nil;
  if (Index > -1) and (Index < Count) then
    Result := PStkDataFileRec(Integer(M.Memory) + SizeOf(TStkDataFileRec) * Index);
end;

end.
