unit fIntfFileIMPL;

{$WARN SYMBOL_PLATFORM OFF}

interface

uses
  ComObj, ActiveX, TEST_007_TLB, StdVcl, fDef;

type
{ TIStkDataFileRec }
  TIStkDataFileRec = class(TAutoObject, IIStkDataFileRec)
  protected
    FRec: PStkDataFileRec;
    function Date: TDateTime; safecall;
    function OP: Single; safecall;
    function HP: Single; safecall;
    function LP: Single; safecall;
    function CP: Single; safecall;
    function VOL: Single; safecall;
  public
    constructor Create(P: PStkDataFileRec);
  end;

{ TIStkDataFile }
  TIStkDataFile = class(TAutoObject, IIStkDataFile)
  protected
    FFile: TStkDataFile;
    function Count: Integer; safecall;
    function Rec(Index: Integer; out P: IIStkDataFileRec): WordBool; safecall;
  public
    constructor Create(F: TStkDataFile);
  end;

{ TIntfFile }
  TIntfFile = class(TAutoObject, IIntfFile)
  protected
    function GetStkDataFile(const FileName: WideString; out F: IIStkDataFile): WordBool; safecall;
  end;

implementation

uses ComServ, SysUtils;

{ TIStkDataFileRec }

constructor TIStkDataFileRec.Create(P: PStkDataFileRec);
begin
  inherited Create;
  FRec := P;
end;

function TIStkDataFileRec.Date: TDateTime;
begin
  Result := FRec.Date;
end;

function TIStkDataFileRec.CP: Single;
begin
  Result := FRec.CP;
end;

function TIStkDataFileRec.HP: Single;
begin
  Result := FRec.HP;
end;

function TIStkDataFileRec.LP: Single;
begin
  Result := FRec.LP;
end;

function TIStkDataFileRec.OP: Single;
begin
  Result := FRec.OP;
end;

function TIStkDataFileRec.VOL: Single;
begin
  Result := FRec.VOL;
end;

{ TIStkDataFile }

function TIStkDataFile.Count: Integer;
begin
  Result := FFile.Count;  
end;

constructor TIStkDataFile.Create(F: TStkDataFile);
begin
  inherited Create;
  FFile := F; 
end;

function TIStkDataFile.Rec(Index: Integer;
  out P: IIStkDataFileRec): WordBool;
begin
  P := nil;
  if FFile[Index] <> nil then
    P := TIStkDataFileRec.Create(FFile[Index]);
  Result := P <> nil;
end;

{ TIntfFile }

function TIntfFile.GetStkDataFile(const FileName: WideString;
  out F: IIStkDataFile): WordBool;
begin
  F := nil;
  if FileExists(FileName) then
    F := TIStkDataFile.Create(TStkDataFile.Create(FileName));
  Result := F <> nil;
end;

initialization
  TAutoObjectFactory.Create(ComServer, TIntfFile, Class_IntfFile, ciMultiInstance, tmApartment);
  TAutoObjectFactory.Create(ComServer, TIStkDataFile, Class_IStkDataFile, ciMultiInstance, tmApartment);
  TAutoObjectFactory.Create(ComServer, TIStkDataFileRec, Class_IStkDataFileRec, ciMultiInstance, tmApartment);

end.
