unit fMain;

interface

uses
  Classes, Forms, Controls, StdCtrls, ExtCtrls;

type
  TfrmMain = class(TForm)
    btnEncapsulation: TButton;
    ListBox1: TListBox;
    btnFileOf: TButton;
    btnFileStream: TButton;
    btnClear: TButton;
    btnMemoryStream: TButton;
    btnFileHandle: TButton;
    btnInterface: TButton;
    Bevel1: TBevel;
    procedure btnEncapsulationClick(Sender: TObject);
    procedure btnFileOfClick(Sender: TObject);
    procedure btnFileStreamClick(Sender: TObject);
    procedure btnClearClick(Sender: TObject);
    procedure btnMemoryStreamClick(Sender: TObject);
    procedure btnInterfaceClick(Sender: TObject);
    procedure btnFileHandleClick(Sender: TObject);
  private
  public
  end;

var
  frmMain: TfrmMain;

implementation

uses SysUtils, fDef, TEST_007_TLB;

{$R *.dfm}

procedure TfrmMain.btnEncapsulationClick(Sender: TObject);
var
  I: Integer;
  L: TStringList;
  F: TStkDataFile;
  P: PStkDataFileRec;
begin
  ListBox1.Clear;
  F := TStkDataFile.Create('TEST.DAT');
  if F <> nil then
  try
    L := TStringList.Create;
    try
      for I := 0 to F.Count-1 do
      begin
        P := F[I];
        if P <> nil then
          L.Add(FormatDateTime('YYYY-MM-DD', P.Date));
      end;
      ListBox1.Items.Text := L.Text;
    finally
      FreeAndNil(L);
    end;
  finally
    FreeAndNil(F);
  end;
end;

procedure TfrmMain.btnFileOfClick(Sender: TObject);
var
  L: TStringList;
  P: TStkDataFileRec;
  F: File of TStkDataFileRec;
begin
  ListBox1.Clear;
  AssignFile(F, 'TEST.DAT');
  try
    Reset(F);
    L := TStringList.Create;
    try
      while not EOF(F) do
      begin
        Read(F, P);
        L.Add(FormatDateTime('YYYY-MM-DD', P.Date));
      end;
      ListBox1.Items.Text := L.Text;
    finally
      FreeAndNil(L);
    end;
  finally
    CloseFile(F);
  end;
end;

procedure TfrmMain.btnFileStreamClick(Sender: TObject);
var
  L: TStringList;
  P: TStkDataFileRec;
  F: TFileStream;
begin
  ListBox1.Clear;
  F := TFileStream.Create('TEST.DAT', fmOpenRead);
  if F <> nil then
  try
    L := TStringList.Create;
    try
      while F.Position < F.Size do
      begin
        F.Read(P, SizeOf(TStkDataFileRec));
        L.Add(FormatDateTime('YYYY-MM-DD', P.Date));
      end;
      ListBox1.Items.Text := L.Text;
    finally
      FreeAndNil(L);
    end;
  finally
    FreeAndNil(F);
  end;
end;

procedure TfrmMain.btnClearClick(Sender: TObject);
begin
  ListBox1.Clear;
end;

procedure TfrmMain.btnMemoryStreamClick(Sender: TObject);
var
  L: TStringList;
  P: TStkDataFileRec;
  F: TMemoryStream;
begin
  ListBox1.Clear;
  F := TMemoryStream.Create;//('TEST.DAT', fmOpenRead);
  F.LoadFromFile('TEST.DAT');
  try
    L := TStringList.Create;
    try
      while F.Position < F.Size do
      begin
        F.Read(P, SizeOf(TStkDataFileRec));
        L.Add(FormatDateTime('YYYY-MM-DD', P.Date));
      end;
      ListBox1.Items.Text := L.Text;
    finally
      FreeAndNil(L);
    end;
  finally
    FreeAndNil(F);
  end;
end;

procedure TfrmMain.btnFileHandleClick(Sender: TObject);
var
  fh: Integer;
  L: TStringList;
  P: TStkDataFileRec;
begin
  ListBox1.Clear;
  fh := FileOpen('TEST.DAT', fmOpenRead);
  if fh > -1 then
  try
    L := TStringList.Create;
    try
      while FileRead(fh, P, SizeOf(P)) = SizeOf(P) do
        L.Add(FormatDateTime('YYYY-MM-DD', P.Date));
      ListBox1.Items.Text := L.Text;
    finally
      FreeAndNil(L);
    end;
  finally
    FileClose(fh);
  end;
end;

procedure TfrmMain.btnInterfaceClick(Sender: TObject);
var
  I, Count: Integer;
  Intf: IIntfFile;
  L: TStringList;
  F: IIStkDataFile;
  P: IIStkDataFileRec;
begin
  ListBox1.Clear;
  Intf := CoIntfFile.Create;
  if (Intf <> nil) and Intf.GetStkDataFile('TEST.DAT', F) then
  try
    L := TStringList.Create;
    try
      Count := F.Count;
      for I := 0 to Count-1 do
        if F.Rec(I, P) then
          L.Add(FormatDateTime('YYYY-MM-DD', P.Date));
      ListBox1.Items.Text := L.Text;
    finally
      FreeAndNil(L);
    end;
  finally
    //F := nil;   //iٲ
    //Intf := nil;//iٲ
  end;
end;

end.
